<?

function mssql_error($db = false) {
 
 if (!$db) {
 $txt = mssql_get_last_message();
 } else {
 $text = mssql_get_last_message();
 
 $sql = "select @@ERROR as code";
 $result = mssql_query($sql, $db);
 $row = mssql_fetch_array($result);
 $code = $row["code"]; 

 if ($code) {
 








 $txt = "[$code] $text";
 } else {
 $txt = "unknown error; $text";
 }
 mssql_free_result($result);
 }
 return $txt;
}

function mssql_affected_rows($db) {
 $rsRows = @mssql_query("select @@rowcount as rows", $db); 
 if (!$rsRows) halt(106, "<B>Error:</b>Could not get affected rows count; ".mssql_error($db));
 return @mssql_result($rsRows, 0, "rows");
}

function mssql_insert_id($db) {
 $rsRows = @mssql_query("select @@IDENTITY as id", $db); 
 if (!$rsRows) halt(106, "<B>Error:</b>Could not get last insert id; ".mssql_error($db));
 return @mssql_result($rsRows, 0, "id");
}


function mydb_mssql_connect($database, $server = "localhost",$login = "",$pw = "",$persistant = true) {
 if ($persistant) $db = mssql_pconnect($server,$login,$pw);
 else $db = mssql_connect($server,$login,$pw);
 if (!$db) halt(106,"<b>ERROR:</b>Could not connect to MSSQL Server $login@$server; ".mssql_error($db));
 else { 
 $err = mssql_select_db($database,$db);
 if (!$err) halt(106,"<b>ERROR:</b>Could not open Database $database ($login@$server); ".mssql_error($db));
 }
 
 return $db;
}

function mydb_mssql_close($db) {
 return @mssql_close($db);
}

function mydb_mssql_exec($sql,$db = 0, $halt = true) {
 global $DB,$HALT;
 if ($db) $mydb = $db;
 else $mydb = $DB;

 if (is_array($mydb)) {
 $handle = $mydb;
 $mydb = $mydb["handle"];
 }
 
 $rs = mssql_query($sql,$mydb);
 if (!$rs) {
 if (!$HALT && $halt) halt(106, "<b>SQL:</b>".$sql."<br><b>ERROR:</b>".mssql_error($mydb));
 }

 return $rs;
}

function mydb_mssql_fetch($rs,$way = MYSQL_BOTH) {
 return mssql_fetch_array($rs);
}



function mydb_mssql_query($sql, $cache = false, $limit = 0, $db = 0, $way = MYSQL_BOTH) {

 if ($cache && strtolower($sql[0]) == "s") return cache($sql, "mssql", $limit, $db, $way);

 global $DB, $DEBUG, $HALT, $QUERY_EFFORT, $QUERY_SPEED, $CACHE_SQL, $DEBUG, $USER_ID, $TIME, $TABLE_LOCK;
 if (!$USER_ID) $USER_ID = 0;

 if ($db) $mydb = $db; else $mydb = $DB;
 if (!$mydb) return false; 

 if (is_array($mydb)) {
 $handle = $mydb;
 $mydb = $mydb["handle"];
 }
 
 if ($DEBUG["log_query"] && (strtolower($sql[0]) == "d" || strtolower($sql[0].$sql[1]) == "up" || strtolower($sql[0]) == "i") && !$TABLE_LOCK && strtolower(substr($sql,0,20)) != "update systemsession") {
 $_sql = "INSERT INTO logrequest (user_id,request,timestamp) VALUES ($USER_ID,'".sqlslashes($sql)."',$TIME)";
 mssql_query($_sql,$mydb);
 }

 if ($DEBUG["echo"]) $t1 = microtime();

 $iid = 0;
 $num = 0;
 $arr = array();

 $cmd = strtolower(substr($sql,0,6));

 if ($cmd == "select" && is_array($limit)) $sql .= " LIMIT ".$limit[0].", ".$limit[1];
 else if ($cmd == "select" && $limit > 0) $sql .= " LIMIT ".$limit;
 $rs = mssql_query($sql,$mydb);
 if (!$rs) {
 if (!$HALT) {



 halt(7, "<b>SQL:</b>".$sql."<br><b>ERROR:</b>".mssql_error($mydb)); 
 }
 else return false;
 }

 if ($cmd == "insert") {
 if (!$cache) $CACHE_SQL = Array();
 $iid = mssql_insert_id($mydb);
 $DEBUG["insert"]++;
 }
 if ($cmd == "select" || substr($cmd,0,4) == "show" || substr($cmd,0,4) == "desc") {
 $DEBUG["select"]++;
 $num = mssql_num_rows($rs);
 
 while ($rs && $row = mssql_fetch_array($rs, MSSQL_BOTH)) $arr[] = $row;
 mssql_free_result($rs);
 }
 if ($cmd == "update") {
 if (!$cache) $CACHE_SQL = Array();
 $DEBUG["update"]++;
 $num = mssql_affected_rows($mydb);
 }
 if ($cmd == "delete") {
 if (!$cache) $CACHE_SQL = Array();
 $DEBUG["delete"]++;
 $num = mssql_affected_rows($mydb);
 }

 $result["arr"] = $arr;
 $result["num"] = $num;
 $result["iid"] = $iid;
 if ($DEBUG["echo"]) {
 $t2 = microtime();
 $tmp = calctime($t1,$t2,5);
 $QUERY_EFFORT += $tmp;
 if ($DEBUG["db"]) { 
 echo "<br>\n$sql\n<br>$tmp num($num) iid($iid)\n<br>";
 flush();
 }
 }
 return $result;
}

function mydb_mssql_create_database($database,$db) {
 return mssql_create_db($database,$db);
}
 

?>
