<?

define( "FM_SEVERITY_ALWAYS", 0x1 );
define( "FM_SEVERITY_SUBMIT", 0x2 );
define( "FM_SEVERITY_DEFAULT", FM_SEVERITY_ALWAYS | FM_SEVERITY_SUBMIT );
define( "FM_SEVERITY_ALL", 0xFFFF );

define( "VK_MOD_SHIFT", 0x00040000 );
define( "VK_MOD_CTRL", 0x00020000 );
define( "VK_MOD_ALT", 0x00010000 );

define( "VK_TAB", 9 );
define( "VK_BACKSPACE", 8 );
define( "VK_ENTER", 13 );
define( "VK_SPACE", 32 );
define( "VK_KP_PLUS", 107 );
define( "VK_KP_MINUS", 109 );
define( "VK_KP_STAR", 106 );
define( "VK_KP_SLASH", 111 );
define( "VK_0", 48 );
define( "VK_1", 49 );
define( "VK_2", 50 );
define( "VK_3", 51 );
define( "VK_4", 52 );
define( "VK_5", 53 );
define( "VK_6", 54 );
define( "VK_7", 55 );
define( "VK_8", 56 );
define( "VK_9", 57 );

define( "VK_A", 65 );
define( "VK_B", 66 );
define( "VK_C", 67 );
define( "VK_D", 68 );
define( "VK_E", 69 );
define( "VK_F", 70 );
define( "VK_G", 71 );
define( "VK_H", 72 );
define( "VK_I", 73 );
define( "VK_J", 74 );
define( "VK_K", 75 );
define( "VK_L", 76 );
define( "VK_M", 77 );
define( "VK_N", 78 );
define( "VK_O", 79 );
define( "VK_P", 80 );
define( "VK_Q", 81 );
define( "VK_R", 82 );
define( "VK_S", 83 );
define( "VK_T", 84 );
define( "VK_U", 85 );
define( "VK_V", 86 );
define( "VK_W", 87 );
define( "VK_X", 88 );
define( "VK_Y", 89 );
define( "VK_Z", 90 );

define( "VK_MASK_KEY", 0x0000FFFF );
define( "VK_MASK_MODS", 0xFFFF0000 );

class FormComponent extends BaseObject {
 var $d_values=array();
 var $d_uniqueKey="";
 var $d_serialized;
 var $d_userFields=array();
 var $d_componentErrors = array();
 var $d_highlightIfRequired = true;

 function FormComponent( $label=NULL, $editable=TRUE, $optional=FALSE ) {
 parent::BaseObject();
 if ( $label !== NULL )
 $this->setLabel( $label );
 $this->setEditable( $editable );
 $this->setOptional( $optional );
 }

 function setLabel( $label ){
 $this->d_values["flabel"] = $label;
 }

 function getLabel( $allowHighlight = false ) {
 global $FEATURE;
 if ( $allowHighlight && $this->d_highlightIfRequired && !$this->isOptional() ) 
 if ( $FEATURE['htmlform_markrequired'] && $this->d_values['flabel'] )
 return '<nobr><strong class="required" title="'.i18n('Required').'">'.$this->d_values['flabel'].'</strong> *</nobr>';
 else
 return $this->d_values['flabel'];
 return $this->d_values["flabel"];
 }
 
 function setHelp( $help ) 
 {
 $this->d_values["fhelp"] = $help;
 }
 
 function getHelp() 
 {
 return $this->d_values["fhelp"];
 }
 
 function setEditable( $isEditable )
 {
 $this->d_values["feditable"] = $isEditable;
 }
 
 function isEditable()
 {
 return $this->d_values["feditable"];
 }

 function setOptional( $isOptional )
 {
 $this->d_values["foptional"] = $isOptional;
 }
 
 function isOptional()
 {
 return $this->d_values["foptional"];
 }
 
 function setOnKeyDown( $key, $script )
 {
 $this->d_values["keydown"][$key] = addslashes($script);
 }
 
 function removeOnKeyDown( $key )
 {
 unset( $this->d_values["keydown"][$key] );
 }
 
 function setShortcut( $key, $script, $override=TRUE )
 {
 if ( !isset( $this->d_values["shortcuts"][$key] ) || $override ) 
 $this->d_values["shortcuts"][$key] = array( "key"=>$key, "script"=>addslashes($script) );
 }
 
 function removeShortcut( $key )
 {
 unset( $this->d_values["shortcuts"][$key] );
 }
 
 function _getModJs( $key, $mod )
 {
 if ( ($key & $mod) == $mod ) 
 return "true";
 return "false"; 
 }
 
 
 function getShortcutsJs()
 {
 if ( count( $this->d_values["shortcuts"] ) == 0 || 
 !is_array( $this->d_values["shortcuts"] ) ) return "";
 
 $first = true;
 $js = "overrideKeys( new Array(";
 foreach ( $this->d_values["shortcuts"] as $shortcut )
 {
 if ( $first ) $first=false; else $js .= ",";
 $js .= "new Array( '".$shortcut["script"]."',";
 $js .= ($shortcut["key"] & VK_MASK_KEY) . ",";
 $js .= $this->_getModJs( $shortcut["key"], VK_MOD_SHIFT ) . ",";
 $js .= $this->_getModJs( $shortcut["key"], VK_MOD_CTRL ) . ",";
 $js .= $this->_getModJs( $shortcut["key"], VK_MOD_ALT );
 $js .= ")";
 }
 $js .= "), event );";
 return $js;
 }
 
 function getOnKeyDown()
 {
 $ret = "";
 if ( is_array($this->d_values["keydown"]) )
 {
 $ret .= implode( " ", $this->d_values["keydown"] );
 }
 
 $js = $this->getShortcutsJs();
 if ( $js )
 $ret .= "return ".$js;
 if ( $ret ) return "onkeydown=\"".$ret."\"";
 return "";
 }
 
 function addJsCheck( $script )
 {
 $this->d_values["jschecks"][] = $script;
 }
 
 




 function getJsChecks()
 {
 $ret = array();
 foreach ( $this->d_values["jschecks"] as $check )
 {
 $c["optional"] = $this->isOptional();
 $c["check"] = $check;
 }
 return $ret;
 }
 
 






 function addUserField( $name, $description ) {
 $this->d_userFields[$name] = $description;
 }
 
 function getUserFields() {
 return $this->d_userFields;
 }

 





 function getFocusableElementName( ) {
 return NULL;
 }

 









 function getFields( $resolveable=FALSE ) {
 return $this->d_userFields;
 }
 
 







 function getError( $severity = FM_SEVERITY_DEFAULT ) {
 $ret = array();
 foreach ( $this->d_componentErrors as $sev=>$errors )
 {
 if ( ($severity & $sev) != 0 )
 {
 $ret = array_merge( $ret, $errors );
 }
 }
 return $ret;
 }

 function setFieldError( $field, $exception, $severity = FM_SEVERITY_SUBMIT ) {
 if ( !isset($this->d_componentErrors[$severity][$field] ) )
 {
 $this->d_componentErrors[$severity][$field] = $exception;
 }
 }
 
 function addError( $exception, $severity = FM_SEVERITY_SUBMIT ) 
 {
 $field = $this->getFocusableElementName();
 if ( $field )
 {
 $this->setFieldError( $field, $exception, $severity );
 }
 else
 {
 $fields = $this->getFields();
 if ( is_array( $fields ) && count( $fields ) > 0 )
 {
 reset( $fields ); 
 $this->setFieldError( key($fields), $exception, $severity );
 }
 }
 }

 







 function isError( $severity = FM_SEVERITY_ALL ) {
 $e = $this->getError($severity);
 if ( $e === NULL ) return FALSE;
 return count($e) > 0;
 }


 







 function getFieldValue( $key ) {
 return $this->d_values[$key];
 }
 
 









 function setFieldValue( $key, $value ) {
 $this->d_values[$key] = $value;
 }

 






 function getSerializeKey() {
 $ret["values"]=$this->d_values;
 $ret["userFields"]=$this->d_userFields;
 return $ret;
 }

 







 function initFromSerializeKey( $key )
 {
 $this->d_values = $key["values"];
 $this->d_userFields = $key["userFields"];
 }
 
 









 function onLoadFinished() { }
 
 function isFinished() {
 $err = $this->getError(FM_SEVERITY_ALL);
 if ( $err !== NULL )
 {
 if ( is_array($err) )
 return count($err) == 0;
 else
 return false;
 }
 return true;

 }

 function getResultObject() { return new NodeException("No Resultobject for FormComponent ".get_class($this)); }
 
 function setObject(&$obj) { }
 
 










 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 foreach ( $this->d_userFields as $field=>$descr )
 {
 $ret .= "<input type=hidden value=\"".htmlentities_utf8($this->d_values[$field])."\" ".
 "name=\"".$fieldPrefix.$field."\">\n";
 }
 return array(array($ret));
 }

 





 function setUniqueKey( $key ) 
 {
 $this->d_uniqueKey = $key;
 }

 function getUniqueKey() {
 return $this->d_uniqueKey;
 }
 
 






 function reset() {}

 function setHidden($hidden) {
 $this->d_values["hidden"] = $hidden;
 }

 function setVisible( $isVisible ) {
 $this->setHidden( !$isVisible );
 }

 function isHidden() {
 return $this->d_values["hidden"];
 }

 function _translateStyle( $doCheck, $checkSeverity ) {
 global $COLOR;
 if ( $this->isError($checkSeverity) ) {
 return "background-color:".$COLOR["inputerr"].";";
 }
 return $doCheck?"background-color:".$COLOR["inputok"].";":"";
 }

 function getErrorDiv(&$form, $fieldprefix) {
 $errordiv = '<div class="error" id="gtxform3_field_'.$fieldprefix.'" classstyle="padding-left: 100px;';
 $errorstr = FALSE;
 $errors = $this->getError();
 foreach( $errors as $err ) {
 $errorstr = $err->getMessage();
 break;
 }
 if( !$errorstr ) {
 $errordiv .= 'display:none;';
 }
 $errordiv .= '">';
 if($errorstr) $errordiv .= $errorstr;
 $errordiv .= '</div>';
 return $errordiv;
 }

 function mergeResult($parent, $code, $disableLabel = true) {
 if (!is_array($parent)) $parent = array($parent);
 if (!is_array($code)) {
 if ($this->getLabel() !== NULL || $disableLabel) {
 $code = array(array($this->getLabel(true), $code));
 } else {
 $code = array(array("", $code));
 }
 }
 foreach ($code as $key=>$ele) $parent[] = $ele;
 return $parent;
 }
 
 function translateRow($row, $addCode = "", $addTd = "", $labelsOnTop = false) {
 if (is_array($row)) {
 $label = $row[0];
 $code = $row[1];
 } else {
 $label = NULL;
 $code = $row;
 }
 if ($label === NULL || $labelsOnTop) {
 if ($label !== NULL) $code = "$label<br \>$code";
 if ($code || $addCode) {
 $out .= "<tr><td colspan=2 $addTd><nobr>$code$addCode</nobr></td></tr>\n";
 }
 } else {
 $out .= "
				<tr valign=\"top\"><td width=\"100\" $addTd>$label</td><td $addTd><nobr>$code$addCode</nobr></td></tr>
				<tr><td><nobr></nobr></td></tr>\n";
 }
 return $out;
 }

 function translateRows($rows, $addCode = "", $addTd = "", $labelsOnTop = false, $clearAddCode = true) {
 if (!is_array($rows)) $rows = array($rows);
 $out = "";
 foreach ($rows as $key=>$row) {
 $out .= $this->translateRow($row, $addCode, $addTd, $labelsOnTop);
 if ($clearAddCode) { $addCode = ""; $addTd = ""; }
 }
 return $out;
 }

 












 function createHelpJsEvents( &$form, $key, $syntax = "" ) {
 
 $help = $this->getHelp();
 
 if ( !$help && !$syntax ) {
 return false;
 }

 $ret = $form->createHelpJs( $key, $this->getLabel(), $syntax, $help );
 
 $ret["html"] = "onmouseover=\"".$ret["onmouseover"].";\" onfocus=\"".$ret["onfocus"].";\" onmouseout=\"".$ret["onmouseout"].";\"";
 
 return $ret;
 }
}

class SelectableFormComponent extends FormComponent
{
 function startSelection()
 {
 $this->d_values["selopen"] = TRUE;
 }
 
 function selectionFinished()
 {
 $this->d_values["selopen"] = FALSE;
 }
 
 function isSelectionOpen()
 {
 return $this->d_values["selopen"];
 }
 
 function isSelectionComplete()
 {
 return $this->isFinished() && !$this->isSelectionOpen();
 }
}

class PlaintextComponent extends FormComponent 
{
 function PlaintextComponent( $text )
 {
 $this->d_values["t"] = $text;
 }

 function getHTML( &$form, $fieldPrefix, $doCheck, $checkSeverity, $key ) {
 return $this->mergeResult(parent::getHTML( $form, $fieldPrefix, $doCheck, $checkSeverity, $key ), 
 $this->d_values["t"] );
 }
 
}
?>