<?php











function extract_portalid( $id, $type )
{
 return substr( $id, 0, -strlen($type) );
}









function portal_fetch_nodes()
{
 global $table, $PDB, $T_PORTALNODE, $T_PORTAL, $USER_ID, $FEATURE;
 
 $sql = "SELECT * " .
 " FROM " . $table["domains"] .
 " GROUP BY portalid ";

 if ( $FEATURE["domains_name"] ) 
 $sql = "SELECT * FROM " . $table["domains"] . " d, domains_internal di WHERE " .
 "d.id = di.domains_id GROUP by portalid";

 if ( $table["domains"] ) $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 
 $row["id"] = $db_row["id"]; 
 if ( $FEATURE["domains_name"] ) $row["name"] = $db_row["name"];
 else $row["name"] = strip_http($db_row["hostname"]);
 $row["type_id"] = $T_PORTALNODE;

 $perm = perm( $USER_ID, $T_PORTALNODE, $row["id"] );
 
 if ( $perm[0] )
 $ret[] = $row; 
 }
 
 $ret = sort2( $ret, "name", "", true );
 return $ret;
}












function portal_fetch_modules( $nid )
{
 global $AVAILABLE_MODULES, $T_TYPE, $PDB, $table, $USER_ID, $FEATURE;

 $sql = "SELECT portalid " .
 " FROM " . $table["domains"] .
 " WHERE id = $nid ";

 $rs = query( $sql, $PDB );
 
 if ( $rs["num"] == 0 )
 return array();

 $portalid = $rs["arr"][0]["portalid"];
 
 $ret = array();
 
 foreach ( $AVAILABLE_MODULES as $type )
 {
 $perm = perm($USER_ID, $type, $portalid.$type);
 if ( $perm[0] ) 
 {

 
 
 $row["id"] = $portalid . $type;
 $row["portalid"] = $portalid;
 $row["name"] = $T_TYPE[$type]["name"];
 $row["type_id"] = $type;
 
 $ret[] = $row;
 }
 }
 return $ret;
}

function portal_fetch_member_groups( $id )
{
 global $PDB, $table, $T_MEMBERS_GROUP;

 $portalid = extract_portalid( $id, $T_MEMBERS_GROUP );

 $sql = "SELECT groupid, name " .
 " FROM " . $table["system_group"].
 " WHERE portalid = $portalid";
 $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["groupid"];
 $row["name"] = $db_row["name"];
 $row["type_id"] = $T_MEMBERS_GROUP;
 $row["portalid"] = $portalid;
 
 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", "", true );
 
 return $ret;
}

function portal_fetch_assistent_groups( $id )
{
 global $PDB, $table, $T_PORTALASSISTENT_GROUP, $T_PORTALASSISTENT ;
 
 $portalid = extract_portalid( $id, $T_PORTALASSISTENT );

 $sql = "SELECT * " .
 " FROM " . $table["assistent_group"] .
 " WHERE portalid = $portalid ";
 $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["id"];
 $row["name"] = $db_row["text"];
 $row["type_id"] = $T_PORTALASSISTENT_GROUP;
 $row["portalid"] = $portalid;
 
 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", "", true );
 
 return $ret;
}


function portal_fetch_voting_groups( $id )
{
 global $PDB, $table, $T_VOTING_GROUP;
 
 $portalid = extract_portalid( $id, $T_VOTING_GROUP );

 $sql = "SELECT * " .
 " FROM " . $table["vorganisation"].
 " WHERE portalid=$portalid ";
 $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["id"];
 $row["name"] = $db_row["friendlyname"];
 $row["type_id"] = $T_VOTING_GROUP;
 $row["portalid"] = $portalid;
 
 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", "", true );
 return $ret;
}

function portal_fetch_ecard_groups( $id )
{
 global $PDB, $table, $T_ECARD_GROUP, $T_ECARD;

 $portalid = extract_portalid( $id, $T_ECARD );
 
 $sql = "SELECT * " .
 " FROM " . $table["greeting_card_category"] .
 " WHERE portalid = $portalid ";
 $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["id"];
 $row["name"] = $db_row["name"];
 $row["type_id"] = $T_ECARD_GROUP;
 $row["portalid"] = $portalid;
 
 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", "", true );
 return $ret;
}

function portal_fetch_addresses_groups ( $id )
{
 global $PDB, $table, $T_ADDRESSES_GROUP, $T_ADDRESSES;

 $portalid = extract_portalid( $id, $T_ADDRESSES );

 $sql = "SELECT * " . 
 " FROM " . $table["addresses_category"] .
 " WHERE portalid = $portalid ";
 $rs = query( $sql, $PDB );

 $ret = array();

 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["id"];
 $row["name"] = $db_row["name"];
 $row["type_id"] = $T_ADDRESSES_GROUP;
 $row["portalid"] = $portalid;

 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", TRUE );

 return $ret;
}

function portal_fetch_newsletter_groups( $id )
{
 global $PDB, $table, $T_NEWSLETTER_GROUP, $T_NEWSLETTER;
 
 $portalid = extract_portalid( $id, $T_NEWSLETTER );
 
 $sql = "SELECT * " .
 " FROM " . $table["newsletter_list"] .
 " WHERE portalid = $portalid ORDER BY name ASC ";
 $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["id"];
 $row["name"] = $db_row["name"];
 $row["type_id"] = $T_NEWSLETTER_GROUP;
 $row["portalid"] = $portalid;
 
 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", "", true );
 return $ret;
}

function portal_fetch_linkengine_groups( $id )
{
 global $PDB, $table, $T_LINKENGINE_GROUP, $T_LINKENGINE;
 
 $portalid = extract_portalid( $id, $T_LINKENGINE );

 $sql = "SELECT * " .
 " FROM " . $table["linkengine_categories"] .
 " WHERE portalid = $portalid ";
 $rs = query( $sql, $PDB );
 
 $ret = array();
 foreach ( $rs["arr"] as $db_row )
 {
 $row = array();
 $row["id"] = $db_row["id"];
 $row["name"] = $db_row["name"];
 $row["type_id"] = $T_LINKENGINE_GROUP;
 $row["portalid"] = $portalid;
 
 $ret[] = $row;
 }
 $ret = sort2( $ret, "name", "", true );
 return $ret;
}

?>
